#
# spec file for package createrepo
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           createrepo
Version:        0.10.3
Release:        5.2
Summary:        Creates a Common Metadata Repository
License:        GPL-2.0+
Group:          System/Packages
Url:            http://linux.duke.edu/metadata/
Source:         http://createrepo.baseurl.org/download/%{name}-%{version}.tar.gz
Patch1:         createrepo-0.9.9-cache_utime.patch
Patch2:         createrepo-0.9.9-cachefix.patch
Patch3:         createrepo-0.9.9-license-to-confirm.patch
Patch4:         createrepo-0.9.9-sort-packages-before-writing-repodata.patch
Patch5:         createrepo-0.9.9-disable-symlinks.patch
Patch6:         createrepo-0.9.9-by_default_no_database.patch
Patch7:         createrepo-0.10.3-modifyrepo-sha.patch
Patch8:         createrepo-0.10.3-fix_MetaDataGenerator.patch
BuildRequires:  python-devel
Requires:       python-deltarpm
Requires:       python-lxml
Requires:       python-urlgrabber
Requires:       rpm >= 4.1.1
Requires:       rpm-python
Requires:       yum-common >= 3.2.25
Requires:       yum-metadata-parser
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This utility generates a common metadata repository from a directory of
RPM packages.

%prep
%setup -q
%patch1
%patch2
%patch3
%patch4 -p1
%patch5
%patch6
%patch7
%patch8 -p1
sed -i "1d" createrepo/{readMetadata,yumbased,utils,deltarpms,merge}.py # Fix non-executable scripts (remove she-bang line)

%build

%install
# Fix the install paths:
sed -i -e 's|PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)|PYLIBDIR = %{py_libdir}|g' \
%if %{suse_version} < 1120
       -e 's|PKGDIR = $(PYLIBDIR)/site-packages/$(PKGNAME)|PKGDIR = %{_datadir}/%{name}/$(PKGNAME)|g' \
%else
       -e 's|PKGDIR = $(PYLIBDIR)/site-packages/$(PKGNAME)|PKGDIR = %{python_sitearch}/%{name}|g' \
%endif
       createrepo/Makefile
%makeinstall sysconfdir=%{_sysconfdir}
mv $RPM_BUILD_ROOT/%{_sysconfdir}/bash_completion.d/createrepo $RPM_BUILD_ROOT/%{_sysconfdir}/bash_completion.d/createrepo.sh
for i in genpkgmetadata.py mergerepo mergerepo.py modifyrepo modifyrepo.py ; do rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/bash_completion.d/$i ; done

%files
%defattr(-,root,root)
%doc ChangeLog COPYING COPYING.lib README
%{_bindir}/*
%{_mandir}/*/*
%config %{_sysconfdir}/bash_completion.d/createrepo.sh
%{_datadir}/%{name}/
%if %{suse_version} >= 1120
%{python_sitearch}/*
%endif

%changelog
* Mon Mar  3 2014 mls@suse.de
- fix last fix
  modified patch: createrepo-0.9.9-sort-packages-before-writing-repodata.patch
* Mon Feb 24 2014 suse-tux@gmx.de
- fix bnc#841280
  new patch: createrepo-0.10.3-fix_MetaDataGenerator.patch
  modified patch: createrepo-0.9.9-sort-packages-before-writing-repodata.patch
* Mon Feb 24 2014 mls@suse.de
- allow 'sha' checksum type in modifyrepo
  new patch: createrepo-0.10.3-modifyrepo-sha.patch
- make it build on sles11 (fix from adrian)
* Mon Feb 24 2014 mls@suse.de
- update to version 0.10.3
  dropped patches:
  * createrepo-0.9.8-workaround-umask-reset.patch
  * createrepo-0.9.9-add-lzma-option-to-generate-primary.xml.lzma.patch
  * createrepo-0.9.9-clean_tmp_files.patch
  * createrepo-0.9.9-generate-gzip-headers.patch
  * createrepo-0.9.9-pass_checksum_to_workers.patch
  * createrepo-0.9.9-use_integer_timestamps.patch
  * createrepo-0.9.9-worker-clog_limit.patch
  new patch:
  * createrepo-0.9.9-by_default_no_database.patch
- fix filename of bash completion script
* Thu Jun 20 2013 jreidinger@suse.com
- write timestamps in seconds (BNC#823652)
* Fri Jun  7 2013 coolo@suse.com
- createrepo/readMetadata.py is using python-libxml2, so require it
* Thu May  2 2013 ro@suse.de
- createrepo-0.9.9-clean_tmp_files.patch:
  remove hunk referencing variables not in this codebase
  (git 850b368ced63b2c0b7f2a4f2fb014d1daba7c80c)
* Wed Apr 24 2013 jreidinger@suse.com
- clean up tmp files (BNC#812071)
* Sat Mar 30 2013 bwiedemann@suse.com
- fix createrepo without clog_limit (bnc#812589)
* Sat Mar 23 2013 suse-tux@gmx.de
- added createrepo-0.9.9-worker-clog_limit.patch in order to
  fix "creatrepo --changelog-limit <num> ..."
* Wed Feb  6 2013 jreidinger@suse.com
- add fix to pass checksum type to workers (BNC#802001)
* Wed Jan 25 2012 saschpe@suse.de
- Spec cleanup:
  * Simplified macro usage
  * Dropped old suse version checks
  * Removed Requires libxml2-python, upstream now uses lxml
  * Package COPYING and COPYING.lib
- Update to version 0.9.9:
  * Bugfix release
- Rebased generate-gzip-headers, disable-symlinks, cache_utime, cachefix,
  license-to-confirm, add-lzma-option-to-generate-primary.xml.lzma,
  sort-packages-before-writing-repodata patches
- Dropped createrepo-0.9.8-disable-deltarpm-1.patch and
  createrepo-0.9.8-disable-deltarpm-2.patch, we now have deltarpm
  Python bindings packaged as 'python-deltarpm'
* Sun Sep 18 2011 jengelh@medozas.de
- Remove redundant tags/sections from specfile
* Fri Jan 14 2011 coolo@novell.com
- pyxml is gone and not needed (bnc#656779)
* Mon Dec 27 2010 mbarringer@suse.de
- rpm resets the umask, which caused bnc#659915.  Working around
  that.
* Tue May 25 2010 mbarringer@novell.com
- Adding an option to skip symlinked directories, in order to fix
  bnc#608213
* Thu May  6 2010 mbarringer@novell.com
- Updating the spec to get the right version of yum
* Sat May  1 2010 mmarek@suse.cz
- Add patches to generate primary.xml.lzma (fate#309167).
* Fri Apr 23 2010 mbarringer@novell.com
- Removing the backwards compatibilty patch, it's not necessary.
* Fri Apr 23 2010 mbarringer@novell.com
- Changing the default checksum type from sha256 to sha1 for
  backwards compatibility.
* Sun Apr 18 2010 coolo@novell.com
- the code requires python-urlgrabber
* Mon Apr 12 2010 mbarringer@novell.com
- Porting patches from 0.4.11:
  - EULA support, in conjunction with a yum patch
  - Explicitly working with older RPMs in the checksum cache
- Removing 0.4.11 patches.  The other functionality in them is either
  in upstream createrepo, or has been moved into yum.
* Thu Apr  1 2010 mbarringer@novell.com
- Patching out the deltarpm support, as we use a different format
* Mon Mar 15 2010 mbarringer@novell.com
- Updating to the latest source
  + Adds repo tags to the generated metadata
  + Adds a --repo option to describe this metadata
  + Adds bash completion
* Wed Oct 14 2009 dmacvicar@novell.com
- update to 0.9.8, disable all patches for now
* Thu Apr 30 2009 lrupp@suse.de
- fix createrepo-0.4.11-hashfix.patch:
  + sha() is also deprecated
  + allow usage on older python versions
- review/port all patches to the current 0.4.11 version
- added rpmlintrc to avoid rpmlint warning for libxml2-python
* Sun Jan 25 2009 cthiel@suse.de
- Fix DeprecationWarnings (bnc#467934, bnc#458460). Thanks to Dmitry Mittov
  for the patches.
* Mon Jan  7 2008 cthiel@suse.de
- fixed exporting of Recommends tag on old distros (#351380)
* Thu Dec  6 2007 cthiel@suse.de
- added modifyrepo-prettyxml.patch to prettify xml output of modifyrepo
* Tue Dec  4 2007 cthiel@suse.de
- update to version 0.4.11
  * adds dmd command
  * adds -i, --pkglist option (use only these files from the directory
    specified)
- drop createrepo-0.4.8-try_sqlitecachec.patch and createrepo-dmd.patch
  (both included upstream)
* Wed Nov 28 2007 adrian@suse.de
- apply fix from mls to avoid dieing createrepo on not nice formated
  changelogs
* Tue Aug  7 2007 cthiel@suse.de
- update to version 0.4.10
  * Adds a --update option to createrepo.
    https://lists.dulug.duke.edu/pipermail/rpm-metadata/2007-March/000756.html
  * dumpMetadata.py: Fix for older rpm versions
- added createrepo-dmd.patch: introduces dmd to generate and apply deltas between
  repository metadata
- added createrepo-0.4.10-fixsymlinks.patch
- reordered patches
* Mon May 21 2007 cthiel@suse.de
- replace rpm.RPMTAG_HDRID with rpm.RPMTAG_SHA1HEADER in createrepo-0.4.8-cachefix.patch
* Wed May 16 2007 cthiel@suse.de
- update to version 0.4.9
  * includes createrepo-0.4.8-skip-symlinks.patch and createrepo-0.4.8-cachefix.patch (partly)
* Tue May 15 2007 cthiel@suse.de
- improve createrepo-0.4.8-cachefix.patch to work on older distros
* Tue May  8 2007 cthiel@suse.de
- added createrepo-0.4.8-cache_utime.patch: touch cache files after using them
* Tue May  8 2007 cthiel@suse.de
- made yum-metadata-parser requirement optional for old distros
* Fri May  4 2007 cthiel@suse.de
- added createrepo-0.4.8-cachefix.patch
  * makes sure to generate unique hashkeys for the cache
* Wed Apr 25 2007 cthiel@suse.de
- added createrepo-0.4.8-skip-symlinks.patch
  * implements -S, --skip-symlinks option
* Fri Feb 16 2007 cthiel@suse.de
- update to version 0.4.8
  * genpkgmetadata.py: merge Jesse Keatings' patch to find groups file
    properly
  * dumpMetadata.py: merge in Christoph Thiel's patch to fix string
    conversion for odd EVR's
  * updated docs
- dropped createrepo-EVR.patch (mereged upstream)
* Wed Feb  7 2007 cthiel@suse.de
- update to version 0.4.7
  * modifyrepo.py: use the mdname for the 'href' element, so it doesn't
    explode when dealing with xml.dom.minidom.Document objects.
  * Makefile, bin/Makefile, createrepo.spec: Makefile changes for
    modifyrepo, and added it to the spec as well.
  * modifyrepo.py, bin/modifyrepo: Initial import
- added Requires: yum-metadata-parser, to support -d option (generate sqlite
  databases for use with yum)
* Wed Jan 10 2007 cthiel@suse.de
- added createrepo-EVR.patch to make _stringToVersion match rpm's parseEVR
  behavior (#228522)
* Thu Aug 17 2006 cthiel@suse.de
- make missing tags work on older distros again
* Mon Aug 14 2006 cthiel@suse.de
- fix build in openSUSE Build Service
* Fri Aug 11 2006 cthiel@suse.de
- update to version 0.4.6
  * Patch from Hans-Peter Jansen -C, --checkts option added
    to avoid metadata generation, if ctime filestamps are up to date.  It's
    currently mutually exclusive with the --split option.
  * Fix cache output dir to 0.4.5 behaviour
  * Fix filtering out path from file list and passing correct path to
    writeMetaData
  * Make splitmetadata handler do it' own getFileList to correctly
    manipulate paths.
  * Set outputdir correctly
  * Move to split basedir and directory everywhere to preserve command line
    paths.  Use os.path.walk rather than our own implementation Improve
    error messages
  * Consistent directory handling and errors
  * Patch from Hans-Peter Jansen to use a more robust rpm header signature
    retrieval method for cache files, as recommended by Jeff Johnson.
  * Tolerate unknown files in repodata dirs
  * patch to support --noepoch for use with old versions of rpm
- remove python-urlgrabber dependency
* Tue May 23 2006 cthiel@suse.de
- added license-to-confirm.patch (by Jose Mercado <jose@novell.com>)
  * adds license-to-confirm element for packages which have EULAs
* Wed Mar 22 2006 cthiel@suse.de
- added createrepo-0.4.4-suse-changelogs.patch (#159882)
  * removes superfluous "- " from author information
    on changelogs
- merged cleanup.patch into missing-tags.patch
* Thu Mar 16 2006 cthiel@suse.de
- update to version 0.4.4
  * introduces split media support
  * adds seperate outputdir option
  * improves cache handling
  * documentation updates
- added Requires: python-urlgrabber
* Wed Mar 15 2006 agruen@suse.de
- Fix a data type conversion bug introduced in the last change
  that triggers with some package repositories. Code cleanup.
* Mon Mar 13 2006 agruen@suse.de
- missing-tags.patch: Include the new Enhances, Supplements,
  Suggests, and Recommends rpm tags in the metadata.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Sep 28 2005 dmueller@suse.de
- add norootforbuild
* Wed Sep 28 2005 cthiel@suse.de
- use cachedir relative to package directory, if cachedir isn't an aboslute
  path
* Wed Sep 28 2005 cthiel@suse.de
- use RPMTAG_SHA1HEADER instead of hdrid in doChecksumCache() [#119199]
* Mon Sep 12 2005 cthiel@suse.de
- specfile cleanup
* Thu Aug 18 2005 cthiel@suse.de
- dropped unneeded patch
* Sun Aug 14 2005 cthiel@suse.de
- use macro py_requires
* Wed Aug  3 2005 cthiel@suse.de
- initial package (version 0.4.3)
